<template>
  <crud-data-table-delete
    v-model="dialog"
    :item-being-deleted="itemBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  >
    <template v-slot:itemBeingDelete>
      {{
        $t('itemBeingDelete', {
          amount: $options.filters.formatCurrency(itemBeingDeleted.amount),
          referenceMonth: $options.filters.formatMonth(itemBeingDeleted.referenceMonth)
        })
      }}
    </template>
    <template v-slot:whatWillHappenWhenDeleted>
      {{ $t('whatWillHappenWhenDeleted') }}
    </template>
  </crud-data-table-delete>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import MoneyMixin from '@/mixins/money'

  export default {
    name: 'DeleteIncomeAmountDialog',
    mixins: [DatesMixin, MoneyMixin],
    data () {
      return {
        dialog: false,
        isLoading: false,
        itemBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeleteIncomeAmount', this.onDeleteIncomeAmount)
    },
    methods: {
      onDeleteIncomeAmount (income) {
        this.itemBeingDeleted = income
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('incomeAmounts/deleteIncomeAmount', {
          ID: this.itemBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          deleteSuccess: 'Item excluído com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir o item. Por favor, tente novamente.',
          itemBeingDelete: 'Valor {amount} no mês de referência {referenceMonth}',
          whatWillHappenWhenDeleted: 'Este valor deixará de ser considerado nos cálculos.',
        },
        'en-US': {
          deleteSuccess: 'Item successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the item. Please try again.',
          itemBeingDelete: 'Amount of {amount} in the reference month {referenceMonth}',
          whatWillHappenWhenDeleted: 'This value will no longer be considered in the calculations.',
        },
      },
    },
  }
</script>
